"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parsePref = void 0;
const parse_npm_tarball_url_1 = __importDefault(require("parse-npm-tarball-url"));
const version_selector_type_1 = __importDefault(require("version-selector-type"));
function parsePref(pref, alias, defaultTag, registry) {
    let name = alias;
    if (pref.startsWith('npm:')) {
        pref = pref.slice(4);
        const index = pref.lastIndexOf('@');
        if (index < 1) {
            name = pref;
            pref = defaultTag;
        }
        else {
            name = pref.slice(0, index);
            pref = pref.slice(index + 1);
        }
    }
    if (name) {
        const selector = (0, version_selector_type_1.default)(pref);
        if (selector != null) {
            return {
                fetchSpec: selector.normalized,
                name,
                type: selector.type,
            };
        }
    }
    if (pref.startsWith(registry)) {
        const pkg = (0, parse_npm_tarball_url_1.default)(pref);
        if (pkg != null) {
            return {
                fetchSpec: pkg.version,
                name: pkg.name,
                normalizedPref: pref,
                type: 'version',
            };
        }
    }
    return null;
}
exports.parsePref = parsePref;
//# sourceMappingURL=parsePref.js.map