"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.workspacePrefToNpm = void 0;
function workspacePrefToNpm(workspacePref) {
    const prefParts = /^workspace:([^._/][^@]*@)?(.*)$/.exec(workspacePref);
    if (prefParts == null) {
        throw new Error(`Invalid workspace spec: ${workspacePref}`);
    }
    const [workspacePkgAlias, workspaceVersion] = prefParts.slice(1);
    const pkgAliasPart = workspacePkgAlias != null && workspacePkgAlias
        ? `npm:${workspacePkgAlias}`
        : '';
    const versionPart = workspaceVersion === '^' || workspaceVersion === '~'
        ? '*'
        : workspaceVersion;
    return `${pkgAliasPart}${versionPart}`;
}
exports.workspacePrefToNpm = workspacePrefToNpm;
//# sourceMappingURL=workspacePrefToNpm.js.map